<template lang="pug">
title-bar {{ client ? client.name : "..." }}
b-container
	.tile.is-ancestor
		.tile.is-vertical
			.tile.is-parent
				b-card.tile.is-child
					client-form( :defaults='client' @submit='save' :loading='pending' )
			.tile.is-parent
				b-card.tile.is-child( :title='$t("default.nav.orders")' )
					orders-table( :orders='orders' :loading='pending' )
</template>

<script setup>
import ClientForm from "@/components/client/Form.vue"
import OrdersTable from "@/components/orders/Table.vue"

import { ref, computed, watch, onMounted } from "vue"

import { useClientsStore } from "@/stores/clients"
import { useRoute } from "vue-router"
import { useToast } from "vue-toastification"
import { useI18n } from "vue-i18n"

const toast = useToast()
const { t } = useI18n()
const cs = useClientsStore()
const $route = useRoute()

const client = ref(null)
const orders = ref(null)
const pending = ref(false)

const id = computed(() => $route.params.clientId)

const fetch = async () => {
	if (pending.value || !id.value) return

	pending.value = true
	
	try {
		const { client: data, orders: clientOrders } = await cs.getClient(id.value)
		
		data.messengers = {
			extra: {},
			main: {}
		}

		data.Messengers.forEach(m => {
			const props = m.extra ? "extra" : "main"

			data.messengers[props][m.name] = true
		})

		orders.value = clientOrders
		client.value = data
	} catch(err) {
		console.error(err)
	}

	pending.value = false
}

const save = async body => {
	if (pending.value) return

	pending.value = true

	try {
		await cs.updateClient(id.value, body)
		toast.success( t("default.changes_saved") )
		await fetch()
	} catch(err) {
		console.error(err)
	}

	pending.value = false
}

watch(() => id.value, fetch)
onMounted(fetch)
</script>